SystemOrganization addCategory: #ConfigurationOfMagritte3!

Object subclass: #ConfigurationOfMagritte3
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMagritte3'!

!ConfigurationOfMagritte3 classSide methodsFor: 'private' stamp: 'NickAger 1/30/2012 11:00'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfMagritte3 classSide methodsFor: 'private' stamp: 'NickAger 1/30/2012 11:00'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfMagritte3 classSide methodsFor: 'metacello tool support' stamp: 'NickAger 1/30/2012 11:00'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMagritte3 classSide methodsFor: 'metacello tool support' stamp: 'NickAger 1/30/2012 11:00'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfMagritte3 classSide methodsFor: 'loading' stamp: 'NickAger 1/30/2012 13:49'!
load
	"self load"
	
	self project stableVersion load! !

!ConfigurationOfMagritte3 classSide methodsFor: 'metacello tool support' stamp: 'NickAger 1/30/2012 11:00'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfMagritte3 classSide methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 11:00'!
project

	^self new project! !

!ConfigurationOfMagritte3 classSide methodsFor: 'release' stamp: 'NickAger 1/30/2012 11:00'!
releaseToGemSource
	"self releaseToGemSource"

	(Smalltalk at: #Gofer) new
		gemsource: 'MetacelloRepository';
		package: self name asString;
		push! !

!ConfigurationOfMagritte3 classSide methodsFor: 'release' stamp: 'NickAger 1/30/2012 11:00'!
releaseToSqueakSource
	"self releaseToSqueakSource"

	(Smalltalk at: #Gofer) new
		squeaksource: 'MetacelloRepository';
		package: self name asString;
		push! !

!ConfigurationOfMagritte3 methodsFor: 'baselines' stamp: 'NickAger 2/23/2012 14:57'!
baseline300: spec
	<version: '3.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec author: 'NickAger'.
		spec timestamp: '01/30/2011 11:02:07'.
		spec repository: 'http://source.lukas-renggli.ch/magritte3'.
		spec 
			project: 'Grease' with: [
				spec
					className: 'ConfigurationOfGrease';
					versionString: #'stable';
					loads: #('Core' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Magritte-Model' with: [
				spec requires: #('Grease' ) ];
			package: 'Magritte-Tests-Model' with: [
				spec requires: #('Magritte-Model' ) ];
			package: 'Magritte-Seaside' with: [
				spec requires: #('Magritte-Model' 'Seaside30' ) ];
			package: 'Magritte-Deprecated' with: [
				spec requires: #('Magritte-Model') ].
		spec 
			group: 'default' with: #('Core' );
			group: 'Core' with: #('Magritte-Model' );
			group: 'Tests' with: #('Magritte-Tests-Model' );
			group: 'Seaside' with: #('Magritte-Seaside');
			group: 'Deprecated' with: #('Magritte-Deprecated') ].

	spec for: #'pharo' do: [
		spec 
			package: 'Magritte-Model' with: [
				spec includes: #('Magritte-Pharo-Model' ). ];
			package: 'Magritte-Tests-Model' with: [
				spec includes: #('Magritte-Tests-Pharo-Model' ). ];
			package: 'Magritte-Seaside' with: [
				spec includes: #('Magritte-Pharo-Seaside' ). ];
			package: 'Magritte-Pharo-Model' with: [
				spec requires: #('Magritte-Model' ). ];
			package: 'Magritte-Tests-Pharo-Model' with: [
				spec requires: #('Magritte-Pharo-Model' ). ];
			package: 'Magritte-Pharo-Seaside' with: [
				spec requires: #('Magritte-Seaside' ). ];
			package: 'Magritte-Morph' with: [
				spec requires: #('Magritte-Model' ). ];
			package: 'Magritte-Pharo-Tools' with: [
				spec requires: #('Magritte-Deprecated' ). ].
		spec
			group: 'Tools' with: #('Magritte-Pharo-Tools') ].
		
	spec for: #gemstone do: [
		spec project: 'GsCore' with: [
			spec
				className: 'ConfigurationOfGsCore';
				versionString: #'bleedingEdge';
				repository: 'http://seaside.gemstone.com/ss/MetacelloRepository' ].		
		spec 
			package: 'Magritte-Model' with: [
				spec 
					requires: #('GsCore' );
					includes: #('Magritte-GemStone-Model' ). ];
			package: 'Magritte-Tests-Model' with: [
				spec includes: #('Magritte-Tests-GemStone-Model' ). ];
			package: 'Magritte-Seaside' with: [
				spec includes: #('Magritte-GemStone-Seaside' ). ];
			package: 'Magritte-GemStone-Model' with: [
				spec requires: #('Magritte-Model' ). ];
			package: 'Magritte-Tests-GemStone-Model' with: [
				spec requires: #('Magritte-GemStone-Model' ). ];
			package: 'Magritte-GemStone-Seaside' with: [
				spec requires: #('Magritte-Seaside' ) ] ]! !

!ConfigurationOfMagritte3 methodsFor: 'symbolic versions' stamp: 'NickAger 1/30/2012 13:34'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '3.0'.
! !

!ConfigurationOfMagritte3 methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 11:00'!
project

	^ project ifNil: [ | projectAttributes |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		project := (Smalltalk at: #MetacelloMCProject) new.
		projectAttributes := #().
		Smalltalk at: #SystemVersion ifPresent: [:cl | | versionString |
			versionString := cl current version.
			((versionString beginsWith: 'Pharo-1.0') or: [versionString beginsWith: 'PharoCore1.0'])
				ifTrue: [ projectAttributes := projectAttributes, #(#'MagritteForPharo1.0') ] ].
		project projectAttributes:  projectAttributes.
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear ]! !

!ConfigurationOfMagritte3 methodsFor: 'symbolic versions' stamp: 'NickAger 1/30/2012 13:34'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'common' version: '3.0'. 
! !

!ConfigurationOfMagritte3 methodsFor: 'versions' stamp: 'NickAger 3/24/2012 08:32'!
version300: spec
	<version: '3.0' imports: #('3.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		
		spec description: '3.0:
- #description replaced by #magritteDescription (#description deprecated)
- MAPragmaBuilder as default - model is now described using pragmas rather than #descriptionXXX naming convention.
- models are described on the instance side and built dynamically - no need for #magritteDynamicObject
- refactoring support (Magritte-Tools) transforms model descriptions into pragmas and moves descriptions from class to instance-side'.
		spec author: 'NickAger'.
		spec timestamp: '30 January 2012 12:55:56 pm'.
		spec 
			project: 'Grease' with: #'stable';
			project: 'Seaside30' with: #'stable'.
		spec 
			package: 'Magritte-Model' with: 'Magritte-Model-NickAger.431';
			package: 'Magritte-Tests-Model' with: 'Magritte-Tests-Model-NickAger.26';
			package: 'Magritte-Seaside' with: 'Magritte-Seaside-NickAger.355';
			package: 'Magritte-Deprecated' with: 'Magritte-Deprecated-NickAger.7' ].

	spec for: #'pharo' do: [
		spec 
			package: 'Magritte-Pharo-Model' with: 'Magritte-Pharo-Model-NickAger.26';
			package: 'Magritte-Tests-Pharo-Model' with: 'Magritte-Tests-Pharo-Model-lr.4';
			package: 'Magritte-Pharo-Seaside' with: 'Magritte-Pharo-Seaside-lr.5';
			package: 'Magritte-Morph' with: 'Magritte-Morph-NickAger.63';
			package: 'Magritte-Pharo-Tools' with: 'Magritte-Pharo-Tools-NickAger.3' ].
	
	spec for: #'gemstone' do: [
		spec project: 'GsCore' with: '0.242'.
		spec 
			package: 'Magritte-GemStone-Model' with: 'Magritte-GemStone-Model-NickAger.3';
			package: 'Magritte-Tests-GemStone-Model' with: 'Magritte-Tests-GemStone-Model-DaleHenrichs.1';
			package: 'Magritte-GemStone-Seaside' with: 'Magritte-GemStone-Seaside-DaleHenrichs.2'.].! !
